#include "adc.h"

void AdcSetRate(void)		//50KSPS@24.000MHz
{
	ADCCFG &= ~0x0f;
	ADCCFG |= 0x04;			//SPEED(4)
	ADCTIM = 0xbf;			//CSSETUP(1), CSHOLD(1), SMPDUTY(31)
}

void ADC_Init(void)
{
	P5M0 |= 0x02; P5M1 &= ~0x02; 
	
	P51 = 1;
	
	//1.ʼio
	P5M0 |= 0x02; P5M1 &= ~0x02;
    P1M0 &= ~0x08; P1M1 |= 0x08; 
	

 
	//2.ʼADCٶ
	AdcSetRate();
	//3.ģʽ
	ADCCFG |= 0X20;
	//4.ADCԴ
	ADC_POWER = 1;

}

u16 ADC_Read(u8 no)
{
	u16 adcvol = 0;
	ADC_CONTR &= 0XF0;  //յλ
	ADC_CONTR |= no;
	
	ADC_START = 1;    // ADת
	_nop_();
	_nop_();
	while(!ADC_FLAG);
	ADC_FLAG = 0;
//	P2 = ADC_RES;
	
	adcvol = (((u16)ADC_RES) << 8) + (ADC_RES);
	
	return adcvol;
}
// 256-64 - 256+64

// 512-64 - (512+64

#define ADC_OFFEST 64 
u8 ADC_KEY_READ( u16 adc)
{
	u16 i ;
	//1.жϵǰûа
	if( adc < (256 - ADC_OFFEST))
	{
		return 0;
	}
	else
	{
		for(i=1;i<=16;i++)
		{
			if((adc >= (i*256 - ADC_OFFEST))&&(adc <= (i*256 + ADC_OFFEST)))
			{
				return i;
			}
		}
	}
	return 0 ;
}

u16 code Temp_Tab[]=
{
	140   ,
	149   ,
	159   ,
	168   ,
	178   ,
	188   ,
	199   ,
	210   ,
	222   ,
	233   ,
	246   ,
	259   ,
	272   ,
	286   ,
	301   ,
	317   ,
	333   ,
	349   ,
	367   ,
	385   ,
	403   ,
	423   ,
	443   ,
	464   ,
	486   ,
	509   ,
	533   ,
	558   ,
	583   ,
	610   ,
	638   ,
	667   ,
	696   ,
	727   ,
	758   ,
	791   ,
	824   ,
	858   ,
	893   ,
	929   ,
	965   ,
	1003  ,
	1041  ,
	1080  ,
	1119  ,
	1160  ,
	1201  ,
	1243  ,
	1285  ,
	1328  ,
	1371  ,
	1414  ,
	1459  ,
	1503  ,
	1548  ,
	1593  ,
	1638  ,
	1684  ,
	1730  ,
	1775  ,
	1821  ,
	1867  ,
	1912  ,
	1958  ,
	2003  ,
	2048  ,
	2093  ,
	2137  ,
	2182  ,
	2225  ,
	2269  ,
	2312  ,
	2354  ,
	2397  ,
	2438  ,
	2479  ,
	2519  ,
	2559  ,
	2598  ,
	2637  ,
	2675  ,
	2712  ,
	2748  ,
	2784  ,
	2819  ,
	2853  ,
	2887  ,
	2920  ,
	2952  ,
	2984  ,
	3014  ,
	3044  ,
	3073  ,
	3102  ,
	3130  ,
	3157  ,
	3183  ,
	3209  ,
	3234  ,
	3259  ,
	3283  ,
	3306  ,
	3328  ,
	3351  ,
	3372  ,
	3393  ,
	3413  ,
	3432  ,
	3452  ,
	3470  ,
	3488  ,
	3506  ,
	3523  ,
	3539  ,
	3555  ,
	3571  ,
	3586  ,
	3601  ,
	3615  ,
	3628  ,
	3642  ,
	3655  ,
	3667  ,
	3679  ,
	3691  ,
	3702  ,
	3714  ,
	3724  ,
	3735  ,
	3745  ,
	3754  ,
	3764  ,
	3773  ,
	3782  ,
	3791  ,
	3799  ,
	3807  ,
	3815  ,
	3822  ,
	3830  ,
	3837  ,
	3844  ,
	3850  ,
	3857  ,
	3863  ,
	3869  ,
	3875  ,
	3881  ,
	3887  ,
	3892  ,
	3897  ,
	3902  ,
	3907  ,
	3912  ,
	3917  ,
	3921  ,
	3926  ,
	3930  ,
	3934  ,
	3938  ,
	3942 ,
};

u16 Temp_Cal(u16 adc)
{
	u8  j = 0;
	u16 k = 0;
	u16 min ;
	u16 max ;
	u16 i;
	
	
	adc = 4096 - adc;
	
	if ( adc < Temp_Tab[0] )
		return 0xfffe;
	if ( adc > Temp_Tab[160] )
		return 0xfffF;
	min = 0;
	max = 160;
	
	for(j=0;j<5;j++ )
	{
		k = (min + max)/2;
		if (adc <= Temp_Tab[k])
			max = k;
		else 
			min = k;
	}
	if (adc = Temp_Tab[min])
		i = min *10;
	else if (adc = Temp_Tab[max])
		i = max *10;
	else
	{
		while (min <= max)
		{
			min++;
			if (Temp_Tab[min] == adc)
			{
				i = min *10;
				break;
			}
			else if ( adc < Temp_Tab[min]  )
			{
				min --;
				i = Temp_Tab[min] ;
				j = Temp_Tab[min+1] - Temp_Tab[min];
				
				j = (adc - i) * 10 /j;
				
				i= min * 10 + j;
				break;
				
			}
		}
	}

	return i;
}
